Bug 1623188 - Review Request: thttpd - tiny, turbo, throttleable lightweight HTTP server
Summary: Review Request: thttpd - tiny, turbo, throttleable lightweight HTTP server
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-08-28 16:45 UTC by Stuart D Gathman
Modified: 2018-09-26 20:16 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-09-23 18:28:38 UTC
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Stuart D Gathman 2018-08-28 16:45:06 UTC
Spec URL: https://gathman.org/linux/SPECS/thttpd.spec
SRPM URL: https://gathman.org/linux/f28/src/thttpd-2.29-1.fc28.src.rpm
Description: 
Thttpd is a very compact no-frills httpd serving daemon that can handle
very high loads. While lacking many of the advanced features of Apache,
thttpd operates without forking and is extremely efficient in memory use.
Basic support for cgi scripts, authentication, and ssi is provided for.
Advanced features include the ability to throttle traffic.

Fedora Account System Username: sdgathman

Comment 1 Stuart D Gathman 2018-08-28 16:51:04 UTC
This is an unretire request.  

cons:
lighttpd is a good alternative to thttpd.  Upstream does not sign, provide checksums, or use https for source releases.

pros:
tiny.  throttling.  No forking.  Low memory.  Very useful for serving a few files from a laptop.

Comment 2 Robert-André Mauchin 2018-08-28 20:48:08 UTC
 - Use:

%post
%systemd_post thttpd.service

%preun
%systemd_preun thttpd.service

%postun
%systemd_postun thttpd.service


 - BR/R for systemd are not good, use instead:

%{?systemd_requires}
BuildRequires: systemd

 - Not needed, it is the default:

%global _hardened_build 1

 - This comment should probably not be in the description.

Available rpmbuild rebuild options :
--with : showversion expliciterrors makeweb
--without : indexes

 - Should probably not be marked as %config

%config %{_unitdir}/thttpd.service

 - Add gcc as a BR

 - %{__make} %{?_smp_mflags} → %make_build

 - Remove the commented prt:

# (list SUBDIRS to exclude "cgi-src")
#%make_build SUBDIRS="extras" WEBDIR=%{webroot} STATICFLAG="" \
#    CCOPT="%{optflags} -D_FILE_OFFSET_BITS=64"

 - Can't you use sed instead of perl -pi -e?




Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If your application is a C or C++ application you must list a
  BuildRequires against gcc, gcc-c++ or clang.
  Note: No gcc, gcc-c++ or clang found in BuildRequires
  See: https://fedoraproject.org/wiki/Packaging:C_and_C%2B%2B


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (2 clause)", "Unknown or generated", "NTP". 29 files have
     unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/thttpd/review-thttpd/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /var/www(cherokee, lua-wsapi,
     httpd-filesystem)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in thttpd-
     debuginfo , thttpd-debugsource
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: thttpd-2.29-1.fc30.x86_64.rpm
          thttpd-debuginfo-2.29-1.fc30.x86_64.rpm
          thttpd-debugsource-2.29-1.fc30.x86_64.rpm
          thttpd-2.29-1.fc30.src.rpm
thttpd.x86_64: W: spelling-error Summary(en_US) throttleable -> throttle able, throttle-able, throttler
thttpd.x86_64: W: spelling-error %description -l en_US httpd -> HTTP
thttpd.x86_64: W: spelling-error %description -l en_US cgi -> chi, cg, cg i
thttpd.x86_64: W: spelling-error %description -l en_US ssi -> sis, sci, psi
thttpd.x86_64: W: spelling-error %description -l en_US rpmbuild -> rpm build, rpm-build, rebuild
thttpd.x86_64: W: spelling-error %description -l en_US showversion -> show version, show-version, subversion
thttpd.x86_64: W: spelling-error %description -l en_US expliciterrors -> explicit errors, explicit-errors, explicitness
thttpd.x86_64: W: spelling-error %description -l en_US makeweb -> make web, make-web, makeweight
thttpd.x86_64: E: missing-call-to-chdir-with-chroot /usr/sbin/thttpd
thttpd.x86_64: W: dangling-relative-symlink /usr/lib/.build-id/24/337f3443daab82367af89ee64a0e70380d3fca ../../../../usr/sbin/makeweb
thttpd.x86_64: W: empty-%postun
thttpd.src: W: spelling-error Summary(en_US) throttleable -> throttle able, throttle-able, throttler
thttpd.src: W: spelling-error %description -l en_US httpd -> HTTP
thttpd.src: W: spelling-error %description -l en_US cgi -> chi, cg, cg i
thttpd.src: W: spelling-error %description -l en_US ssi -> sis, sci, psi
thttpd.src: W: spelling-error %description -l en_US rpmbuild -> rpm build, rpm-build, rebuild
thttpd.src: W: spelling-error %description -l en_US showversion -> show version, show-version, subversion
thttpd.src: W: spelling-error %description -l en_US expliciterrors -> explicit errors, explicit-errors, explicitness
thttpd.src: W: spelling-error %description -l en_US makeweb -> make web, make-web, makeweight
thttpd.src:59: W: macro-in-comment %make_build
thttpd.src:59: W: macro-in-comment %{webroot}
thttpd.src:60: W: macro-in-comment %{optflags}
thttpd.src:377: W: macro-in-%changelog %{buildroot}
4 packages and 0 specfiles checked; 1 errors, 22 warnings.

Comment 3 Stuart D Gathman 2018-08-29 00:30:28 UTC
Spec URL: https://gathman.org/linux/SPECS/thttpd.spec
SRPM URL: https://gathman.org/linux/f27/src/thttpd-2.29-2.fc27.src.rpm

I wonder if the with/without rebuild options are done correctly?  In my SPECs I use %bcond_with and %bcond_without.

Comment 4 Stuart D Gathman 2018-08-29 00:36:34 UTC
Regarding the rpmlint error, it sure looks like it calls chdir after chroot in the source.  What does rpmlint look at?

Comment 5 Robert-André Mauchin 2018-08-30 19:21:32 UTC
(In reply to Stuart D Gathman from comment #3)
> Spec URL: https://gathman.org/linux/SPECS/thttpd.spec
> SRPM URL: https://gathman.org/linux/f27/src/thttpd-2.29-2.fc27.src.rpm
> 
> I wonder if the with/without rebuild options are done correctly?  In my
> SPECs I use %bcond_with and %bcond_without.

They do work as advertised.

(In reply to Stuart D Gathman from comment #4)
> Regarding the rpmlint error, it sure looks like it calls chdir after chroot
> in the source.  What does rpmlint look at?

I've looked at the source code too and didn't notice something amiss.

Package approved.

Comment 6 Fedora Update System 2018-09-06 20:56:47 UTC
thttpd-2.29-2.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2018-d513082b6e

Comment 7 Fedora Update System 2018-09-06 20:56:53 UTC
thttpd-2.29-2.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2018-e71337389d

Comment 8 Fedora Update System 2018-09-06 20:56:59 UTC
thttpd-2.29-2.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-6c622cccab

Comment 9 Fedora Update System 2018-09-06 20:57:05 UTC
thttpd-2.29-2.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2018-d9627f1703

Comment 10 Fedora Update System 2018-09-07 06:01:16 UTC
thttpd-2.29-2.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-e71337389d

Comment 11 Fedora Update System 2018-09-07 15:18:46 UTC
thttpd-2.29-2.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-d9627f1703

Comment 12 Fedora Update System 2018-09-07 15:47:37 UTC
thttpd-2.29-2.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2018-d513082b6e

Comment 13 Fedora Update System 2018-09-07 17:11:34 UTC
thttpd-2.29-2.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-6c622cccab

Comment 14 Fedora Update System 2018-09-23 18:28:38 UTC
thttpd-2.29-2.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.

Comment 15 Fedora Update System 2018-09-23 18:29:21 UTC
thttpd-2.29-2.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.

Comment 16 Fedora Update System 2018-09-23 20:18:35 UTC
thttpd-2.29-2.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.

Comment 17 Fedora Update System 2018-09-26 20:16:11 UTC
thttpd-2.29-2.fc27 has been pushed to the Fedora 27 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.